"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantClassification(ProtocolElement):
    """
    The variant classification according to different properties.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import reports as reports_6_1_1

        return {
            "clinicalSignificance": reports_6_1_1.ClinicalSignificance,
            "drugResponseClassification": reports_6_1_1.DrugResponseClassification,
            "functionalEffect": reports_6_1_1.VariantFunctionalEffect,
            "traitAssociation": reports_6_1_1.TraitAssociation,
            "tumorigenesisClassification": reports_6_1_1.TumorigenesisClassification,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import reports as reports_6_1_1

        return {
            "org.gel.models.report.avro.ClinicalSignificance": reports_6_1_1.ClinicalSignificance,
            "org.gel.models.report.avro.DrugResponseClassification": reports_6_1_1.DrugResponseClassification,
            "org.gel.models.report.avro.VariantFunctionalEffect": reports_6_1_1.VariantFunctionalEffect,
            "org.gel.models.report.avro.TraitAssociation": reports_6_1_1.TraitAssociation,
            "org.gel.models.report.avro.TumorigenesisClassification": reports_6_1_1.TumorigenesisClassification,
            "org.gel.models.report.avro.VariantClassification": reports_6_1_1.VariantClassification,
        }

    __slots__ = [
        "clinicalSignificance",
        "drugResponseClassification",
        "functionalEffect",
        "traitAssociation",
        "tumorigenesisClassification",
    ]

    def __init__(
        self,
        clinicalSignificance=None,
        drugResponseClassification=None,
        functionalEffect=None,
        traitAssociation=None,
        tumorigenesisClassification=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_1_1.VariantClassification model.

        :param clinicalSignificance:
            The variant's clinical significance.
        :type clinicalSignificance: None | ClinicalSignificance
        :param drugResponseClassification:
            The variant's pharmacogenomics classification.
        :type drugResponseClassification: None | DrugResponseClassification
        :param functionalEffect:
            The variant functional effect
        :type functionalEffect: None | VariantFunctionalEffect
        :param traitAssociation:
            The variant's trait association.
        :type traitAssociation: None | TraitAssociation
        :param tumorigenesisClassification:
            The variant's tumorigenesis classification.
        :type tumorigenesisClassification: None | TumorigenesisClassification
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.1.1"
